(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('rxjs'), require('@ngrx/store'), require('primeng/button'), require('@angular/common'), require('@angular/forms')) :
    typeof define === 'function' && define.amd ? define('share-state', ['exports', '@angular/core', 'rxjs', '@ngrx/store', 'primeng/button', '@angular/common', '@angular/forms'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global["share-state"] = {}, global.ng.core, global.rxjs, global.i1, global.i2, global.ng.common, global.ng.forms));
})(this, (function (exports, i0, rxjs, i1, i2, i3, forms) { 'use strict';

    function _interopNamespace(e) {
        if (e && e.__esModule) return e;
        var n = Object.create(null);
        if (e) {
            Object.keys(e).forEach(function (k) {
                if (k !== 'default') {
                    var d = Object.getOwnPropertyDescriptor(e, k);
                    Object.defineProperty(n, k, d.get ? d : {
                        enumerable: true,
                        get: function () { return e[k]; }
                    });
                }
            });
        }
        n["default"] = e;
        return Object.freeze(n);
    }

    var i0__namespace = /*#__PURE__*/_interopNamespace(i0);
    var i1__namespace = /*#__PURE__*/_interopNamespace(i1);
    var i2__namespace = /*#__PURE__*/_interopNamespace(i2);
    var i3__namespace = /*#__PURE__*/_interopNamespace(i3);

    var ShareStateService = /** @class */ (function () {
        function ShareStateService() {
            this.dataTransfer$ = new rxjs.Subject();
        }
        Object.defineProperty(ShareStateService.prototype, "user", {
            get: function () {
                return this.userName;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ShareStateService.prototype, "shareObj", {
            get: function () {
                return this.shareObject;
            },
            enumerable: false,
            configurable: true
        });
        ShareStateService.prototype.login = function (userName, password) {
            this.userName = userName;
        };
        ShareStateService.prototype.setObject = function (obj) {
            this.shareObject = obj;
            this.dataTransfer$.next(obj);
        };
        return ShareStateService;
    }());
    ShareStateService.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0__namespace, type: ShareStateService, deps: [], target: i0__namespace.ɵɵFactoryTarget.Injectable });
    ShareStateService.ɵprov = i0__namespace.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0__namespace, type: ShareStateService, providedIn: 'root' });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0__namespace, type: ShareStateService, decorators: [{
                type: i0.Injectable,
                args: [{
                        providedIn: 'root',
                    }]
            }], ctorParameters: function () { return []; } });

    var increment = i1.createAction('[Counter Component] Increment');
    var decrement = i1.createAction('[Counter Component] Decrement');
    var reset = i1.createAction('[Counter Component] Reset');

    var ShareStateComponent = /** @class */ (function () {
        function ShareStateComponent(store) {
            this.store = store;
            this.count$ = store.select('count');
        }
        ShareStateComponent.prototype.ngOnInit = function () {
        };
        ShareStateComponent.prototype.increment = function () {
            console.log("+++");
            this.store.dispatch(increment());
        };
        ShareStateComponent.prototype.decrement = function () {
            this.store.dispatch(decrement());
        };
        ShareStateComponent.prototype.reset = function () {
            this.store.dispatch(reset());
        };
        return ShareStateComponent;
    }());
    ShareStateComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0__namespace, type: ShareStateComponent, deps: [{ token: i1__namespace.Store }], target: i0__namespace.ɵɵFactoryTarget.Component });
    ShareStateComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.0.5", type: ShareStateComponent, selector: "lib-share-state", ngImport: i0__namespace, template: "<p>\n  about works!\n</p>\n<div>{{count$ | async  }}</div>\n<p-button (click)=\"increment()\">increment</p-button>\n<p-button (click)=\"decrement()\">decrement</p-button>\n<p-button (click)=\"reset()\">reset</p-button>", components: [{ type: i2__namespace.Button, selector: "p-button", inputs: ["type", "iconPos", "icon", "badge", "label", "disabled", "loading", "loadingIcon", "style", "styleClass", "badgeClass"], outputs: ["onClick", "onFocus", "onBlur"] }], pipes: { "async": i3__namespace.AsyncPipe } });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0__namespace, type: ShareStateComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'lib-share-state',
                        templateUrl: './share-state.component.html',
                        styleUrls: [],
                    }]
            }], ctorParameters: function () { return [{ type: i1__namespace.Store }]; } });

    var initialState = 0;
    var counterReducer = i1.createReducer(initialState, i1.on(increment, function (state) { return state + 1; }), i1.on(decrement, function (state) { return state - 1; }), i1.on(reset, function (state) { return 0; }));

    var ShareStateModule = /** @class */ (function () {
        function ShareStateModule() {
        }
        return ShareStateModule;
    }());
    ShareStateModule.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0__namespace, type: ShareStateModule, deps: [], target: i0__namespace.ɵɵFactoryTarget.NgModule });
    ShareStateModule.ɵmod = i0__namespace.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0__namespace, type: ShareStateModule, declarations: [ShareStateComponent], imports: [forms.FormsModule,
            i3.CommonModule,
            i2.ButtonModule, i1__namespace.StoreRootModule], exports: [ShareStateComponent] });
    ShareStateModule.ɵinj = i0__namespace.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0__namespace, type: ShareStateModule, imports: [[
                forms.FormsModule,
                i3.CommonModule,
                i2.ButtonModule,
                i1.StoreModule.forRoot({ count: counterReducer }),
            ]] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0__namespace, type: ShareStateModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [
                            ShareStateComponent
                        ],
                        imports: [
                            forms.FormsModule,
                            i3.CommonModule,
                            i2.ButtonModule,
                            i1.StoreModule.forRoot({ count: counterReducer }),
                        ],
                        exports: [
                            ShareStateComponent
                        ]
                    }]
            }] });

    /*
     * Public API Surface of share-state
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.ShareStateComponent = ShareStateComponent;
    exports.ShareStateModule = ShareStateModule;
    exports.ShareStateService = ShareStateService;
    exports.counterReducer = counterReducer;
    exports.decrement = decrement;
    exports.increment = increment;
    exports.initialState = initialState;
    exports.reset = reset;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=share-state.umd.js.map
