import * as i0 from '@angular/core';
import { Injectable, Component, NgModule } from '@angular/core';
import { Subject } from 'rxjs';
import * as i1 from '@ngrx/store';
import { createAction, createReducer, on, StoreModule } from '@ngrx/store';
import * as i2 from 'primeng/button';
import { ButtonModule } from 'primeng/button';
import * as i3 from '@angular/common';
import { CommonModule } from '@angular/common';
import { FormsModule } from '@angular/forms';

class ShareStateService {
    constructor() {
        this.dataTransfer$ = new Subject();
    }
    get user() {
        return this.userName;
    }
    get shareObj() {
        return this.shareObject;
    }
    login(userName, password) {
        this.userName = userName;
    }
    setObject(obj) {
        this.shareObject = obj;
        this.dataTransfer$.next(obj);
    }
}
ShareStateService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: ShareStateService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
ShareStateService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: ShareStateService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: ShareStateService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root',
                }]
        }], ctorParameters: function () { return []; } });

const increment = createAction('[Counter Component] Increment');
const decrement = createAction('[Counter Component] Decrement');
const reset = createAction('[Counter Component] Reset');

class ShareStateComponent {
    constructor(store) {
        this.store = store;
        this.count$ = store.select('count');
    }
    ngOnInit() {
    }
    increment() {
        console.log("+++");
        this.store.dispatch(increment());
    }
    decrement() {
        this.store.dispatch(decrement());
    }
    reset() {
        this.store.dispatch(reset());
    }
}
ShareStateComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: ShareStateComponent, deps: [{ token: i1.Store }], target: i0.ɵɵFactoryTarget.Component });
ShareStateComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.0.5", type: ShareStateComponent, selector: "lib-share-state", ngImport: i0, template: "<p>\n  about works!\n</p>\n<div>{{count$ | async  }}</div>\n<p-button (click)=\"increment()\">increment</p-button>\n<p-button (click)=\"decrement()\">decrement</p-button>\n<p-button (click)=\"reset()\">reset</p-button>", components: [{ type: i2.Button, selector: "p-button", inputs: ["type", "iconPos", "icon", "badge", "label", "disabled", "loading", "loadingIcon", "style", "styleClass", "badgeClass"], outputs: ["onClick", "onFocus", "onBlur"] }], pipes: { "async": i3.AsyncPipe } });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: ShareStateComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'lib-share-state',
                    templateUrl: './share-state.component.html',
                    styleUrls: [],
                }]
        }], ctorParameters: function () { return [{ type: i1.Store }]; } });

const initialState = 0;
const counterReducer = createReducer(initialState, on(increment, (state) => state + 1), on(decrement, (state) => state - 1), on(reset, (state) => 0));

class ShareStateModule {
}
ShareStateModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: ShareStateModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
ShareStateModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: ShareStateModule, declarations: [ShareStateComponent], imports: [FormsModule,
        CommonModule,
        ButtonModule, i1.StoreRootModule], exports: [ShareStateComponent] });
ShareStateModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: ShareStateModule, imports: [[
            FormsModule,
            CommonModule,
            ButtonModule,
            StoreModule.forRoot({ count: counterReducer }),
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: ShareStateModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        ShareStateComponent
                    ],
                    imports: [
                        FormsModule,
                        CommonModule,
                        ButtonModule,
                        StoreModule.forRoot({ count: counterReducer }),
                    ],
                    exports: [
                        ShareStateComponent
                    ]
                }]
        }] });

/*
 * Public API Surface of share-state
 */

/**
 * Generated bundle index. Do not edit.
 */

export { ShareStateComponent, ShareStateModule, ShareStateService, counterReducer, decrement, increment, initialState, reset };
//# sourceMappingURL=share-state.js.map
